diff --git a/src/plugins/qnx/mediaplayer/mmrenderermediaplayercontrol.cpp b/src/plugins/qnx/mediaplayer/mmrenderermediaplayercontrol.cpp
index 503c5be..217f8b3 100644
--- a/src/plugins/qnx/mediaplayer/mmrenderermediaplayercontrol.cpp
+++ b/src/plugins/qnx/mediaplayer/mmrenderermediaplayercontrol.cpp
@@ -538,7 +538,6 @@ void MmRendererMediaPlayerControl::play()
         return;
     }
 
-    m_stopEventsToIgnore = 0;    // once playing, stop events must be proccessed
     setState( QMediaPlayer::PlayingState);
 }
 
diff --git a/src/plugins/qnx/mediaplayer/mmrendererplayervideorenderercontrol.cpp b/src/plugins/qnx/mediaplayer/mmrendererplayervideorenderercontrol.cpp
index f95cd8a..98999ee 100644
--- a/src/plugins/qnx/mediaplayer/mmrendererplayervideorenderercontrol.cpp
+++ b/src/plugins/qnx/mediaplayer/mmrendererplayervideorenderercontrol.cpp
@@ -167,45 +167,45 @@ void MmRendererPlayerVideoRendererControl::frameGrabbed(const QImage &frame, int
 {
     if (m_surface) {
         if (!m_surface->isActive()) {
-            if (m_windowGrabber->eglImageSupported()) {
-                if (QOpenGLContext::currentContext())
-                    m_windowGrabber->createEglImages();
-                else
-                    m_surface->setProperty("_q_GLThreadCallback", QVariant::fromValue<QObject*>(this));
-
-                m_surface->start(QVideoSurfaceFormat(frame.size(), QVideoFrame::Format_BGR32,
-                                                 QAbstractVideoBuffer::GLTextureHandle));
-            } else {
+//            if (m_windowGrabber->eglImageSupported()) {
+//                if (QOpenGLContext::currentContext())
+//                    m_windowGrabber->createEglImages();
+//                else
+//                    m_surface->setProperty("_q_GLThreadCallback", QVariant::fromValue<QObject*>(this));
+
+//                m_surface->start(QVideoSurfaceFormat(frame.size(), QVideoFrame::Format_BGR32,
+//                                                 QAbstractVideoBuffer::GLTextureHandle));
+//            } else {
                 m_surface->start(QVideoSurfaceFormat(frame.size(), QVideoFrame::Format_ARGB32));
-            }
+//            }
         } else {
             if (m_surface->surfaceFormat().frameSize() != frame.size()) {
                 QAbstractVideoBuffer::HandleType type = m_surface->surfaceFormat().handleType();
                 m_surface->stop();
-                if (type != QAbstractVideoBuffer::NoHandle) {
-                    m_surface->setProperty("_q_GLThreadCallback", QVariant::fromValue<QObject*>(this));
-                    m_surface->start(QVideoSurfaceFormat(frame.size(), QVideoFrame::Format_BGR32,
-                                                     QAbstractVideoBuffer::GLTextureHandle));
-                } else {
+//                if (type != QAbstractVideoBuffer::NoHandle) {
+//                    m_surface->setProperty("_q_GLThreadCallback", QVariant::fromValue<QObject*>(this));
+//                    m_surface->start(QVideoSurfaceFormat(frame.size(), QVideoFrame::Format_BGR32,
+//                                                     QAbstractVideoBuffer::GLTextureHandle));
+//                } else {
                     m_surface->start(QVideoSurfaceFormat(frame.size(), QVideoFrame::Format_ARGB32));
-                }
+//                }
             }
         }
 
         // Depending on the support of EGL images on the current platform we either pass a texture
         // handle or a copy of the image data
-        if (m_surface->surfaceFormat().handleType() != QAbstractVideoBuffer::NoHandle) {
-            if (m_windowGrabber->eglImagesInitialized() &&
-                    m_surface->property("_q_GLThreadCallback") != 0)
-                m_surface->setProperty("_q_GLThreadCallback", 0);
+//        if (m_surface->surfaceFormat().handleType() != QAbstractVideoBuffer::NoHandle) {
+//            if (m_windowGrabber->eglImagesInitialized() &&
+//                    m_surface->property("_q_GLThreadCallback") != 0)
+//                m_surface->setProperty("_q_GLThreadCallback", 0);
 
 
-            BBTextureBuffer *textBuffer = new BBTextureBuffer(handle);
-            QVideoFrame actualFrame(textBuffer, frame.size(), QVideoFrame::Format_BGR32);
-            m_surface->present(actualFrame);
-        } else {
+//            BBTextureBuffer *textBuffer = new BBTextureBuffer(handle);
+//            QVideoFrame actualFrame(textBuffer, frame.size(), QVideoFrame::Format_BGR32);
+//            m_surface->present(actualFrame);
+//        } else {
             m_surface->present(frame.copy());
-        }
+//        }
     }
 }