--- 55.txt	2015-09-24 11:14:00.967428700 +0200
+++ 56.txt	2015-09-24 11:14:10.833483700 +0200
@@ -82,12 +82,12 @@
         "version": "2.2"
     },
     {
-        "classname": "QtQuick2Plugin",
-        "name": "QtQuick",
-        "path": "/qtbase/qml/QtQuick.2",
-        "plugin": "qtquick2plugin",
+        "classname": "QtQuickLayoutsPlugin",
+        "name": "QtQuick.Layouts",
+        "path": "/qtbase/qml/QtQuick/Layouts",
+        "plugin": "qquicklayoutsplugin",
         "type": "module",
-        "version": "2.4"
+        "version": "1.0"
     },
     {
         "name": "QtQuick.Controls.Private",
@@ -96,105 +96,42 @@
         "version": "1.0"
     },
     {
-        "classname": "QtQuick2DialogsPlugin",
-        "name": "QtQuick.Dialogs",
-        "path": "/qtbase/qml/QtQuick/Dialogs",
-        "plugin": "dialogplugin",
-        "type": "module",
-        "version": "1.0"
-    },
-    {
-        "classname": "QtQuick2WindowPlugin",
-        "name": "QtQuick.Window",
-        "path": "/qtbase/qml/QtQuick/Window.2",
-        "plugin": "windowplugin",
-        "type": "module",
-        "version": "2.1"
-    },
-    {
-        "name": "qml",
-        "path": "/qtbase/qml/QtQuick/Dialogs/DefaultColorDialog.qml/qml",
-        "type": "directory"
-    },
-    {
-        "classname": "QtQuick2DialogsPlugin",
-        "name": "QtQuick.Dialogs",
-        "path": "/qtbase/qml/QtQuick/Dialogs",
-        "plugin": "dialogplugin",
-        "type": "module",
-        "version": "1.2"
-    },
-    {
-        "name": "qml",
-        "path": "/qtbase/qml/QtQuick/Dialogs/DefaultDialogWrapper.qml/qml",
-        "type": "directory"
-    },
-    {
-        "classname": "QtQuick2DialogsPrivatePlugin",
-        "name": "QtQuick.Dialogs.Private",
-        "path": "/qtbase/qml/QtQuick/Dialogs/Private",
-        "plugin": "dialogsprivateplugin",
-        "type": "module",
-        "version": "1.1"
-    },
-    {
-        "classname": "QmlFolderListModelPlugin",
-        "name": "Qt.labs.folderlistmodel",
-        "path": "/qtbase/qml/Qt/labs/folderlistmodel",
-        "plugin": "qmlfolderlistmodelplugin",
-        "type": "module",
-        "version": "2.1"
-    },
-    {
-        "name": "qml",
-        "path": "/qtbase/qml/QtQuick/Dialogs/DefaultFileDialog.qml/qml",
-        "type": "directory"
-    },
-    {
         "name": "QtQuick.Controls.Styles",
         "path": "/qtbase/qml/QtQuick/Controls/Styles",
         "type": "module",
-        "version": "1.0"
-    },
-    {
-        "name": "qml",
-        "path": "/qtbase/qml/QtQuick/Dialogs/DefaultFontDialog.qml/qml",
-        "type": "directory"
+        "version": "1.1"
     },
     {
-        "name": "qml",
-        "path": "/qtbase/qml/QtQuick/Dialogs/DefaultMessageDialog.qml/qml",
-        "type": "directory"
+        "classname": "QtQuick2Plugin",
+        "name": "QtQuick",
+        "path": "/qtbase/qml/QtQuick.2",
+        "plugin": "qtquick2plugin",
+        "type": "module",
+        "version": "2.4"
     },
     {
         "name": "QtQuick.Controls.Styles",
         "path": "/qtbase/qml/QtQuick/Controls/Styles",
         "type": "module",
-        "version": "1.1"
+        "version": "1.2"
     },
     {
-        "classname": "QtQuick2PrivateWidgetsPlugin",
-        "name": "QtQuick.PrivateWidgets",
-        "path": "/qtbase/qml/QtQuick/PrivateWidgets",
-        "plugin": "widgetsplugin",
+        "classname": "QtQuick2Plugin",
+        "name": "QtQuick",
+        "path": "/qtbase/qml/QtQuick.2",
+        "plugin": "qtquick2plugin",
         "type": "module",
-        "version": "1.0"
+        "version": "2.1"
     },
     {
-        "classname": "QtQuick2PrivateWidgetsPlugin",
-        "name": "QtQuick.PrivateWidgets",
-        "path": "/qtbase/qml/QtQuick/PrivateWidgets",
-        "plugin": "widgetsplugin",
+        "classname": "QtQuickControlsPlugin",
+        "name": "QtQuick.Controls",
+        "path": "/qtbase/qml/QtQuick/Controls",
+        "plugin": "qtquickcontrolsplugin",
         "type": "module",
         "version": "1.1"
     },
     {
-        "name": "QtQuick.Controls.Styles",
-        "path": "/qtbase/qml/QtQuick/Controls/Styles",
-        "type": "module",
-        "version": "1.2"
-    },
-    {
         "classname": "QtQuick2Plugin",
         "name": "QtQuick",
         "path": "/qtbase/qml/QtQuick.2",
@@ -217,12 +154,12 @@
         "version": "1.4"
     },
     {
-        "classname": "QtQuickLayoutsPlugin",
-        "name": "QtQuick.Layouts",
-        "path": "/qtbase/qml/QtQuick/Layouts",
-        "plugin": "qquicklayoutsplugin",
+        "classname": "QtQuick2WindowPlugin",
+        "name": "QtQuick.Window",
+        "path": "/qtbase/qml/QtQuick/Window.2",
+        "plugin": "windowplugin",
         "type": "module",
-        "version": "1.0"
+        "version": "2.1"
     },
     {
         "name": "QtQuick.Extras.Private",
@@ -230,6 +167,7 @@
         "version": "1.0"
     },
     {
+        "classname": "QtGraphicalEffectsPlugin",
         "name": "QtGraphicalEffects",
         "path": "/qtbase/qml/QtGraphicalEffects",
         "type": "module",
@@ -288,6 +226,14 @@
         "type": "directory"
     },
     {
+        "classname": "QtQuick2Plugin",
+        "name": "QtQuick",
+        "path": "/qtbase/qml/QtQuick.2",
+        "plugin": "qtquick2plugin",
+        "type": "module",
+        "version": "2.6"
+    },
+    {
         "classname": "QtQmlModelsPlugin",
         "name": "QtQml.Models",
         "path": "/qtbase/qml/QtQml/Models.2",
@@ -296,150 +242,16 @@
         "version": "2.2"
     },
     {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/Blend.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/BrightnessContrast.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/Colorize.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/ColorOverlay.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/ConicalGradient.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/Desaturate.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/DirectionalBlur.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/Displace.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/DropShadow.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/FastBlur.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/GammaAdjust.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/GaussianBlur.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/Glow.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/HueSaturation.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/InnerShadow.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/LevelAdjust.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/LinearGradient.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/MaskedBlur.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/OpacityMask.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/RadialBlur.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/RadialGradient.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/RectangularGlow.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/RecursiveBlur.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/ThresholdMask.qml/private",
-        "type": "directory"
-    },
-    {
-        "name": "private",
-        "path": "/qtbase/qml/QtGraphicalEffects/ZoomBlur.qml/private",
-        "type": "directory"
-    },
-    {
-        "classname": "QtQuick2Plugin",
-        "name": "QtQuick",
-        "path": "/qtbase/qml/QtQuick.2",
-        "plugin": "qtquick2plugin",
-        "type": "module",
-        "version": "2.1"
-    },
-    {
         "name": "HelperWidgets",
         "type": "module",
         "version": "2.0"
     },
     {
-        "classname": "QtQuickControlsPlugin",
-        "name": "QtQuick.Controls",
-        "path": "/qtbase/qml/QtQuick/Controls",
-        "plugin": "qtquickcontrolsplugin",
+        "name": "QtGraphicalEffects.private",
+        "path": "/qtbase/qml/QtGraphicalEffects/private",
+        "plugin": "qtgraphicaleffectsprivate",
         "type": "module",
-        "version": "1.1"
+        "version": "1.0"
     }
 ]
 